function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var reactTinyPopover = require('react-tiny-popover');
var ReactHtmlParser = _interopDefault(require('react-html-parser'));
var uuid = require('uuid');
var magReactComponents = require('mag-react-components');
var reactBootstrapTypeahead = require('react-bootstrap-typeahead');
var axios = _interopDefault(require('axios'));

var styles = {"toggle":"_1_VU4","container":"_1WhfM","containerTitle":"_1pe0W","containerBody":"_Lzse6","magPopoverContainer":"_3_PxX"};

function MagPopover(_ref) {
  var title = _ref.title,
      definition = _ref.definition;

  var _useState = React.useState(false),
      isPopoverOpen = _useState[0],
      setIsPopoverOpen = _useState[1];

  return /*#__PURE__*/React__default.createElement(reactTinyPopover.Popover, {
    containerClassName: styles.magPopoverContainer,
    isOpen: isPopoverOpen,
    positions: ['right', 'bottom', 'left'],
    padding: 10,
    style: {
      zIndex: 99999
    },
    content: function content(_ref2) {
      var position = _ref2.position,
          childRect = _ref2.childRect,
          popoverRect = _ref2.popoverRect;
      return /*#__PURE__*/React__default.createElement(reactTinyPopover.ArrowContainer, {
        position: position,
        childRect: childRect,
        popoverRect: popoverRect,
        arrowColor: "black",
        arrowSize: 8
      }, /*#__PURE__*/React__default.createElement("div", {
        className: styles.container
      }, /*#__PURE__*/React__default.createElement("div", {
        className: styles.containerTitle
      }, title), /*#__PURE__*/React__default.createElement("div", {
        className: styles.containerBody
      }, ReactHtmlParser(definition))));
    }
  }, /*#__PURE__*/React__default.createElement("span", {
    style: {
      display: definition && definition !== '' ? 'block' : 'none'
    },
    className: styles.toggle + ' mag-popover',
    onMouseEnter: function onMouseEnter() {
      return setIsPopoverOpen(true);
    },
    onMouseLeave: function onMouseLeave() {
      return setIsPopoverOpen(false);
    }
  }, /*#__PURE__*/React__default.createElement("i", {
    className: "fas fa-info-circle"
  })));
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

var styles$1 = {"sidebar":"_1m-WA","sidebarHeader":"_2-Dkw","sidebarItem":"_2yQYl","sidebarPanel":"_1Oj0M","activeSidebarPanel":"_aiYQV","sidebarPanelHeader":"_30eGA","arrowLeft":"_2uUUH"};

function SidebarItem(props) {
  var iconClass = props.iconClass,
      label = props.label,
      active = props.active,
      sidebarItemClicked = props.sidebarItemClicked;
  return /*#__PURE__*/React__default.createElement("div", null, /*#__PURE__*/React__default.createElement("div", {
    style: {
      backgroundColor: active ? 'var(--secondaryColor)' : ''
    },
    className: styles$1.sidebarItem + ' mag-sidebar-item',
    onClick: function onClick() {
      return sidebarItemClicked(props);
    }
  }, /*#__PURE__*/React__default.createElement("div", null, /*#__PURE__*/React__default.createElement("i", {
    className: iconClass
  }), /*#__PURE__*/React__default.createElement("span", {
    className: "liLabel"
  }, label))), /*#__PURE__*/React__default.createElement("span", {
    className: styles$1.arrowLeft,
    style: {
      display: active ? 'inline-block' : 'none'
    }
  }));
}

function SidebarPanelHeader(_ref) {
  var title = _ref.title,
      closeSidebarPanel = _ref.closeSidebarPanel;
  return /*#__PURE__*/React__default.createElement("div", {
    className: styles$1.sidebarPanelHeader
  }, /*#__PURE__*/React__default.createElement("span", null, title), /*#__PURE__*/React__default.createElement("button", {
    title: "Close Panel",
    onClick: closeSidebarPanel
  }, /*#__PURE__*/React__default.createElement("i", {
    className: "fas fa-times"
  })));
}

function SidebarPanel(_ref) {
  var activeItem = _ref.activeItem,
      isSidebarActive = _ref.isSidebarActive,
      closeSidebarPanel = _ref.closeSidebarPanel;
  return /*#__PURE__*/React__default.createElement("div", {
    className: isSidebarActive ? styles$1.activeSidebarPanel + ' mag-sidebar-panel' : styles$1.sidebarPanel + ' mag-sidebar-panel'
  }, /*#__PURE__*/React__default.createElement(SidebarPanelHeader, {
    className: styles$1.sidebarPanelHeader,
    title: activeItem ? activeItem.panelTitle : '',
    closeSidebarPanel: closeSidebarPanel
  }), activeItem ? activeItem.panel() : '');
}

function Sidebar(_ref) {
  var title = _ref.title,
      sidebarItems = _ref.sidebarItems,
      sidebarHeaderImage = _ref.sidebarHeaderImage,
      color = _ref.color,
      CustomHeader = _ref.CustomHeader,
      sidebarClass = _ref.sidebarClass,
      width = _ref.width;
  sidebarItems = sidebarItems.map(function (item) {
    item.id = uuid.v4();
    return item;
  });

  var _useState = React.useState(sidebarItems),
      items = _useState[0],
      setItems = _useState[1];

  function sidebarItemClicked(e) {
    setItems(items.map(function (item) {
      if (item.id === e.id) {
        if (item.panel) {
          item.active = !item.active;
        }

        if (item.onClick) {
          item.onClick(_extends({}, item));
        }
      } else {
        item.active = false;
      }

      return item;
    }));
  }

  function closeSidebarPanel() {
    setItems(items.map(function (item) {
      item.active = false;
      return item;
    }));
  }

  var activeItems = items.filter(function (_ref2) {
    var active = _ref2.active;
    return active;
  });
  var activeItem = activeItems.length === 1 ? activeItems[0] : null;
  var isSidebarActive = activeItem !== null;
  return /*#__PURE__*/React__default.createElement("section", {
    style: {
      backgroundColor: color
    },
    className: styles$1.sidebar + ' mag-sidebar'
  }, /*#__PURE__*/React__default.createElement("div", {
    className: sidebarClass,
    style: {
      width: width ? width + 'px' : '100px'
    }
  }, CustomHeader ? /*#__PURE__*/React__default.createElement(CustomHeader, null) : /*#__PURE__*/React__default.createElement("div", {
    className: styles$1.sidebarHeader + ' mag-sidebar-header'
  }, /*#__PURE__*/React__default.createElement("img", {
    title: title,
    width: "65",
    src: sidebarHeaderImage,
    alt: "Bikemap Icon"
  })), title ? /*#__PURE__*/React__default.createElement("h2", null, title) : '', sidebarItems.map(function (_ref3) {
    var label = _ref3.label,
        active = _ref3.active,
        iconClass = _ref3.iconClass,
        id = _ref3.id;
    return /*#__PURE__*/React__default.createElement(SidebarItem, {
      key: id,
      id: id,
      label: label,
      iconClass: iconClass,
      active: active,
      sidebarItemClicked: sidebarItemClicked
    });
  })), /*#__PURE__*/React__default.createElement(SidebarPanel, {
    isSidebarActive: isSidebarActive,
    activeItem: activeItem,
    closeSidebarPanel: closeSidebarPanel
  }));
}

var styles$2 = {"layerListCheckbox":"_1X7ML"};

function LayerListItem(_ref) {
  var _id = _ref._id,
      title = _ref.title,
      visible = _ref.visible,
      definition = _ref.definition,
      _onChange = _ref.onChange;
  return /*#__PURE__*/React__default.createElement("div", {
    className: styles$2.layerListItem
  }, /*#__PURE__*/React__default.createElement("input", {
    onChange: function onChange() {
      return _onChange(_id);
    },
    type: "checkbox",
    defaultChecked: visible
  }), title, /*#__PURE__*/React__default.createElement(magReactComponents.Popover, {
    definition: definition,
    title: title
  }), /*#__PURE__*/React__default.createElement("br", null));
}

function LayerList(_ref) {
  var layerListConfig = _ref.layerListConfig,
      getMapRef = _ref.getMapRef;
  var llConf = [].concat(layerListConfig);
  llConf = llConf.map(function (item) {
    if (!item._id) {
      item.key = uuid.v4();
      item._id = uuid.v4();
    }

    return item;
  });

  var _useState = React.useState(llConf),
      layerList = _useState[0],
      setLayerList = _useState[1];

  function onChange(_id) {
    try {
      var _layerList$filter = layerList.filter(function (listItem) {
        return listItem._id === _id;
      }),
          currentLayerListItem = _layerList$filter[0];

      setLayerList(function (prevLayerList) {
        var modifiedLayerList = prevLayerList.map(function (listItem) {
          if (listItem._id === _id) {
            listItem.visible = !listItem.visible;
          }

          return listItem;
        });
        return [].concat(modifiedLayerList);
      });

      if (currentLayerListItem) {
        var _getMapRef = getMapRef(),
            map = _getMapRef.map;

        var layer = map.findLayerById(currentLayerListItem.id);
        layer.visible = currentLayerListItem.visible;
      }
    } catch (error) {
      console.log(error);
    }
  }

  return /*#__PURE__*/React__default.createElement("div", {
    className: styles$2.layerList
  }, layerListConfig.map(function (item) {
    return /*#__PURE__*/React__default.createElement(LayerListItem, _extends({
      onChange: onChange
    }, item));
  }));
}

// A type of promise-like that resolves synchronously and supports only one observer

const _iteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.iterator || (Symbol.iterator = Symbol("Symbol.iterator"))) : "@@iterator";

const _asyncIteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.asyncIterator || (Symbol.asyncIterator = Symbol("Symbol.asyncIterator"))) : "@@asyncIterator";

// Asynchronously call a function and send errors to recovery continuation
function _catch(body, recover) {
	try {
		var result = body();
	} catch(e) {
		return recover(e);
	}
	if (result && result.then) {
		return result.then(void 0, recover);
	}
	return result;
}

var getAddressOptions = function getAddressOptions(term) {
  try {
    return Promise.resolve(_catch(function () {
      var url = 'https://geocode.arcgis.com/arcgis/rest/services/World/GeocodeServer/findAddressCandidates';
      return Promise.resolve(axios.get(url + "?category=Address,Postal&maxLocations=6&distance=539130&location=-112.053569,33.490526&f=json&singleLine=" + term)).then(function (res) {
        return res.data && res.data.candidates && res.data.candidates.length > 0 ? res.data.candidates.map(function (candidate) {
          return _extends({}, candidate, {
            id: uuid.v4()
          });
        }) : res;
      });
    }, function (error) {
      console.log(error);
    }));
  } catch (e) {
    return Promise.reject(e);
  }
};

var AsyncTypeahead = reactBootstrapTypeahead.withAsync(reactBootstrapTypeahead.Typeahead);
function AddressTypeahead(_ref) {
  var onChange = _ref.onChange;

  var _useState = React.useState([]),
      options = _useState[0],
      setOptions = _useState[1];

  var _useState2 = React.useState(false),
      isLoading = _useState2[0],
      setIsLoading = _useState2[1];

  return /*#__PURE__*/React__default.createElement("div", null, /*#__PURE__*/React__default.createElement(AsyncTypeahead, {
    isLoading: isLoading,
    labelKey: "address",
    id: "1",
    filterBy: function filterBy(test) {
      return true;
    },
    onSearch: function onSearch(query) {
      (function () {
        try {
          var _temp2 = function () {
            if (query.length > 4) {
              setIsLoading(true);
              return Promise.resolve(getAddressOptions(query)).then(function (addressCandidates) {
                setOptions(function () {
                  return addressCandidates;
                });
                setIsLoading(false);
              });
            }
          }();

          return _temp2 && _temp2.then ? _temp2.then(function () {}) : void 0;
        } catch (e) {
          Promise.reject(e);
        }
      })();
    },
    options: options,
    onChange: onChange
  }));
}

var Popover = MagPopover;
var Sidebar$1 = Sidebar;
var LayerList$1 = LayerList;
var AddressTypeahead$1 = AddressTypeahead;

exports.AddressTypeahead = AddressTypeahead$1;
exports.LayerList = LayerList$1;
exports.Popover = Popover;
exports.Sidebar = Sidebar$1;
//# sourceMappingURL=index.js.map
